/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/

// THE MALAY ISLAND:
// CREATED BY DANY:
// JANUARY 2008:

/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
		int subCiv3=-1; 

/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(2) == true) 
	{
		subCiv0=rmGetCivID("Jesuit");
		rmEchoInfo("subCiv0 is Jesuit "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "Jesuit");

		subCiv1=rmGetCivID("Sufi");
		rmEchoInfo("subCiv1 is Sufi "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "Sufi");
    
        subCiv2=rmGetCivID("Jesuit");
		rmEchoInfo("subCiv2 is Jesuit "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "Jesuit");

		subCiv3=rmGetCivID("Sufi");
		rmEchoInfo("subCiv3 is Sufi "+subCiv3);
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "Sufi");
	}
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

	    int playerTiles = 25000;
	    		
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(632, 632);
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //  
/*================================================================================================================*/

	    // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.05, 10, 0.4, 7.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // SET SEA LEVEL:
		rmSetSeaLevel(1.0);
	    
		// SET LIGHTING:
		rmSetLightingSet("Borneo");

	    // SET SEA TYPE:
		rmSetSeaType("borneo coast");
	
	    // SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("borneo_grass_a");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	
	    // SET MAP TYPE:
		rmSetMapType("borneo");
	    rmSetMapType("grass");
	    rmSetMapType("water");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(3.0);

	    // CHOOSE MERCS:
		chooseMercs();
	
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
		rmDefineClass("socketClass");
		rmDefineClass("natives");
		rmDefineClass("startingUnit");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
    
	// MAP EDGE CONSCIENCES:
	int playerEdgeConstraint=rmCreateBoxConstraint("stuff vs player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
    int playerCloseEdgeConstraint=rmCreateBoxConstraint("close vs player edge of map", rmXTilesToFraction(15), rmZTilesToFraction(15), 1.0-rmXTilesToFraction(15), 1.0-rmZTilesToFraction(15), 0.01);
    int playerVeryCloseEdgeConstraint=rmCreateBoxConstraint("very close vs player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
    int playerFarEdgeConstraint=rmCreateBoxConstraint("far vs player edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);

	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stuff vs players", classPlayer, 15.0);
    int playerCloseConstraint=rmCreateClassDistanceConstraint("close vs players", classPlayer, 10.0);
    int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs players", classPlayer, 5.0);
    int playerFarConstraint=rmCreateClassDistanceConstraint("far vs players", classPlayer, 25.0);

	// FOREST CONSTRAINT:
	int forestConstraint=rmCreateClassDistanceConstraint("stuff vs. forest", rmClassID("classForest"), 15.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
	int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 5.0);
	int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 25.0);
	int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 45.0);
	   
	// AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("stuff vs impassable land", "Land", false, 15.0);
	int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close vs impassable land", "Land", false, 10.0);
	int avoidVeryCloseImpassableLand=rmCreateTerrainDistanceConstraint("very close vs impassable land", "Land", false, 5.0);
	int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium vs impassable land", "Land", false, 20.0);
	int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far vs impassable land", "Land", false, 25.0);

    // SILVER AVOIDANCE:
	int avoidSilver=rmCreateTypeDistanceConstraint("stuff avoid silver", "mine", 15.0);
    int avoidCloseSilver=rmCreateTypeDistanceConstraint("close avoid silver", "mine", 10.0);
    int avoidVeryCloseSilver=rmCreateTypeDistanceConstraint("very close avoid silver", "mine", 5.0);
    int avoidMediumSilver=rmCreateTypeDistanceConstraint("medium avoid silver", "mine", 25.0);
    int avoidFarSilver=rmCreateTypeDistanceConstraint("far avoid silver", "mine", 65.0);
    int avoidVeryFarSilver=rmCreateTypeDistanceConstraint("very far avoid silver", "mine", 90.0);
	
	// HUNTABLE1 AVOIDANCE:
	int avoidHuntable1=rmCreateTypeDistanceConstraint("stuff avoid huntable1", "ypSerow", 15.0);
	int avoidCloseHuntable1=rmCreateTypeDistanceConstraint("close avoid huntable1", "ypSerow", 10.0);
	int avoidVeryCloseHuntable1=rmCreateTypeDistanceConstraint("very close avoid huntable1", "ypSerow", 5.0);
	int avoidMediumHuntable1=rmCreateTypeDistanceConstraint("medium avoid huntable1", "ypSerow", 30.0);
	int avoidFarHuntable1=rmCreateTypeDistanceConstraint("far avoid huntable1", "ypSerow", 65.0);
	int avoidVeryFarHuntable1=rmCreateTypeDistanceConstraint("very far avoid huntable1", "ypSerow", 90.0);
	
	// HUNTABLE2 AVOIDANCE:
	int avoidHuntable2=rmCreateTypeDistanceConstraint("stuff avoid huntable2", "ypWildElephant", 15.0);
	int avoidCloseHuntable2=rmCreateTypeDistanceConstraint("close avoid huntable2", "ypWildElephant", 10.0);
	int avoidVeryCloseHuntable2=rmCreateTypeDistanceConstraint("very close avoid huntable2", "ypWildElephant", 5.0);
	int avoidMediumHuntable2=rmCreateTypeDistanceConstraint("medium avoid huntable2", "ypWildElephant", 30.0);
	int avoidFarHuntable2=rmCreateTypeDistanceConstraint("far avoid huntable2", "ypWildElephant", 65.0);
	int avoidVeryFarHuntable2=rmCreateTypeDistanceConstraint("very far avoid huntable2", "ypWildElephant", 90.0);
    
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("stuff vs. nugget", "AbstractNugget", 15.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close vs. nugget", "AbstractNugget", 10.0);
	int avoidCloseVeryNugget=rmCreateTypeDistanceConstraint("very close vs. nugget", "AbstractNugget", 5.0);
	int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium vs. nugget", "AbstractNugget", 30.0);
	int avoidFarNugget=rmCreateTypeDistanceConstraint("far vs. nugget", "AbstractNugget", 75.0);
	
	// WATER NUGGET AVOIDANCE:
	int avoidNuggetWater=rmCreateTypeDistanceConstraint("nugget vs. nugget water", "AbstractNugget", 90.0);
    	  
	// BERRIES AVOIDANCE:
	int avoidBerries=rmCreateTypeDistanceConstraint("stuff avoid berries", "berrybush", 15.0);
	int avoidCloseBerries=rmCreateTypeDistanceConstraint("close avoid berries", "berrybush", 10.0);
    int avoidVeryCloseBerries=rmCreateTypeDistanceConstraint("very close avoid berries", "berrybush", 5.0);
    int avoidMediumBerries=rmCreateTypeDistanceConstraint("Medium avoid berries", "berrybush", 25.0);
    int avoidFarBerries=rmCreateTypeDistanceConstraint("far avoid berries", "berrybush", 65.0);
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff vs natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close vs natives", rmClassID("natives"), 10.0);
	int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close vs natives", rmClassID("natives"), 5.0);
	int avoidMediumNatives=rmCreateClassDistanceConstraint("medium vs natives", rmClassID("natives"), 25.0);
	int avoidFarNatives=rmCreateClassDistanceConstraint("far vs natives", rmClassID("natives"), 60.0);
		
	// GENARAL AVOIDANCE:
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 7.0);
	
	// TREE AVOIDANCE:
	int avoidMediumTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "ypTreeBorneo", 25.0);
        
	// LAND AVOIDANCE:
	int avoidLand = rmCreateTerrainDistanceConstraint("ship avoid land", "land", true, 15.0);
	
	// STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	  
    // FISH & WHALE CONSTRAINTS:
    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "ypFishMolaMola", 20.0);	
	int fishVsFish2ID=rmCreateTypeDistanceConstraint("fish v fish2", "ypFishTuna", 20.0); 
	int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);			
  
    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 80.0);
	int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 20.0);
    int whaleEdgeConstraint=rmCreatePieConstraint("whale edge of map", 0.5, 0.5, 0, rmGetMapXSize()-20, 0, 0, 0);

    // FLAG CONSTRAINTS:
    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 18.0);
    int nuggetVsFlag = rmCreateTypeDistanceConstraint("nugget v flag", "HomeCityWaterSpawnFlag", 8.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 25.0);
	int flagEdgeConstraint=rmCreatePieConstraint("flag edge of map", 0.5, 0.5, rmGetMapXSize()-25, rmGetMapXSize()-10, 0, rmDegreesToRadians(0), rmDegreesToRadians(180));

	// TRADE ROUTE AVOIDANCE:
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("stuff vs trade route", 15.0);
    int avoidCloseTradeRoute=rmCreateTradeRouteDistanceConstraint("close vs trade route", 10.0);
    int avoidVeryCloseTradeRoute=rmCreateTradeRouteDistanceConstraint("very close vs trade route", 5.0);

	// SOCKETS AVOIDANCE:
	int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 15.0);
	int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 10.0);
    int avoidVeryCloseSocket=rmCreateClassDistanceConstraint("very close avoid sockets", rmClassID("socketClass"), 5.0);

	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
        
        // DEFINE SOME OBJECTS:
	    // DONE DEFINING SOME OBJECTS:
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE ISLAND: ***************************************** //  
/*================================================================================================================*/
  
        // MAKE THE ISLAND:

	    int mainIslandID=rmCreateArea("indochina");

	    rmSetAreaSize(mainIslandID, 0.4, 0.4);
  
	    rmSetAreaCoherence(mainIslandID, 0.75);
	    rmSetAreaBaseHeight(mainIslandID, 3.0);
        
		rmSetAreaLocation(mainIslandID, .5, .5);
	   
	    rmSetAreaSmoothDistance(mainIslandID, 20);
	    rmSetAreaMix(mainIslandID, "borneo_grass_a");
		
        rmSetAreaObeyWorldCircleConstraint(mainIslandID, false);
	    rmSetAreaElevationType(mainIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(mainIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(mainIslandID, 0.09);
	    rmSetAreaElevationOctaves(mainIslandID, 3);
	    rmSetAreaElevationPersistence(mainIslandID, 0.2);
	    rmSetAreaElevationNoiseBias(mainIslandID, 1);
	    rmSetAreaWarnFailure(mainIslandID, false);
	    
		rmBuildArea(mainIslandID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE MAIN RIVER: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE INVISIBLE ISLAND FOR NATIVES: ***************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("south trade route");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 6.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
    
		rmAddTradeRouteWaypoint(tradeRouteID, 0.375, 0.775); // STARTING THE SQUARE TRADE ROUTE:
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.575, 0.575);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.775, 0.375);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.625, 0.225);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.425, 0.425);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.225, 0.625);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.375, 0.775); // CLOSING THE SQUARE TRADE ROUTE:
		
		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "water");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
/*================================================================================================================*/

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.375, 0.775);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.575, 0.575); 
        rmPlaceObjectDefAtLoc(socketID, 0, 0.775, 0.375); 		
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.625, 0.225);
        rmPlaceObjectDefAtLoc(socketID, 0, 0.425, 0.425); 		
		rmPlaceObjectDefAtLoc(socketID, 0, 0.225, 0.625);
        
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/

            if(rmRandFloat(0,1) > 0.50)
	    {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.55, 0.75, 0.75, 0.55, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.45, 0.25, 0.25, 0.45, 0, 0.0);
		}
		    else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.45, 0.25, 0.25, 0.45, 0, 0.0);
	
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.55, 0.75, 0.75, 0.55, 0, 0.0);
		}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
 
        float playerFraction=rmAreaTilesToFraction(2250);
        
		for(i=1; <cNumberPlayers) 
	{
        // CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, shortAvoidImportantItem); 
        //rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, true);
    }

	    // BUILD THE AREAS:
        rmBuildAllAreas();
    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
        if (subCiv0 == rmGetCivID("Jesuit")) 
   {  
        int JesuitVillage1ID = -1;
        int JesuitVillageType = rmRandInt(1,5);
        JesuitVillage1ID = rmCreateGrouping("Jesuit village 1", "native jesuit mission borneo 0"+JesuitVillageType);
        rmSetGroupingMinDistance(JesuitVillage1ID, 0.0);
        rmSetGroupingMaxDistance(JesuitVillage1ID, 0.0);
        rmAddGroupingToClass(JesuitVillage1ID, rmClassID("natives"));
		rmAddGroupingConstraint(JesuitVillage1ID, avoidNatives);
    
        rmPlaceGroupingAtLoc(JesuitVillage1ID, 0, 0.4, 0.6); 
   }	
   
/*----------------------------------------------------------------------------------------------------------------*/
        
		if (subCiv1 == rmGetCivID("Sufi")) 
   {   
      int SufiVillage1ID = -1;
      int SufiVillageType = rmRandInt(1,5);
      SufiVillage1ID = rmCreateGrouping("Sufi village 1", "native sufi mosque borneo "+SufiVillageType);
      rmSetGroupingMinDistance(SufiVillage1ID, 0.0);
      rmSetGroupingMaxDistance(SufiVillage1ID, 0.0);
      rmAddGroupingToClass(SufiVillage1ID, rmClassID("natives"));
      rmAddGroupingConstraint(SufiVillage1ID, avoidNatives);
      
      rmPlaceGroupingAtLoc(SufiVillage1ID, 0, 0.6, 0.4);
   }

/*----------------------------------------------------------------------------------------------------------------*/
        
		if (cNumberNonGaiaPlayers <=2)
{		
		if (subCiv2 == rmGetCivID("Jesuit")) 
   {  
        int JesuitVillage2ID = -1;
        JesuitVillageType = rmRandInt(1,5);
        JesuitVillage2ID = rmCreateGrouping("Jesuit village 2", "native jesuit mission borneo 0"+JesuitVillageType);
        rmSetGroupingMinDistance(JesuitVillage2ID, 0.0);
        rmSetGroupingMaxDistance(JesuitVillage2ID, 0.0);
        rmAddGroupingToClass(JesuitVillage2ID, rmClassID("natives"));
		rmAddGroupingConstraint(JesuitVillage2ID, avoidNatives);
    
        rmPlaceGroupingAtLoc(JesuitVillage2ID, 0, 0.75, 0.55); 
   }	

/*--------------------------------------------------------------------------------------------------------------*/

      if (subCiv3 == rmGetCivID("Sufi")) 
   {   
      int SufiVillage2ID = -1;
      SufiVillageType = rmRandInt(1,5);
      SufiVillage2ID = rmCreateGrouping("Sufi village 2", "native sufi mosque borneo "+SufiVillageType);
      rmSetGroupingMinDistance(SufiVillage2ID, 0.0);
      rmSetGroupingMaxDistance(SufiVillage2ID, 0.0);
      rmAddGroupingToClass(SufiVillage2ID, rmClassID("natives"));
      rmAddGroupingConstraint(SufiVillage2ID, avoidNatives);
      
      rmPlaceGroupingAtLoc(SufiVillage2ID, 0, 0.25, 0.45);
   }    
}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************* DEFINE THE STARTING TCID AND STARTING UNITS AND RESOURCES: ************************* //  
/*================================================================================================================*/
 
        // DEFINE THE STARTING TCID:
        int startingTCID= rmCreateObjectDef("startingTC");
	    if (rmGetNomadStart()) 
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
    }
		
        else 
	{
        rmAddObjectDefItem(startingTCID, "townCenter", 1, 0.0);
    }

        rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
	    //rmAddObjectDefConstraint(startingTCID, avoidNatives);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));
	
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    
		
/*---------------------------------------------------------------------------------------------------------------*/
	
	    // DEFINE THE START SILVER:
		int startSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(startSilverID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(startSilverID, 10.0);
	    rmSetObjectDefMaxDistance(startSilverID, 20.0);
		rmAddObjectDefToClass(startSilverID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(startSilverID, avoidStartingUnits);
		rmAddObjectDefConstraint(startSilverID, avoidMediumSilver);
	    rmAddObjectDefConstraint(startSilverID, avoidAll);
	    		
		// DEFINE THE START TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "ypTreeBorneo", 10, 7.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 20);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 35);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
        rmAddObjectDefConstraint(StartAreaTreeID, avoidMediumTree);
	    		
		// DEFINE THE START BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 5.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 20);
	    rmSetObjectDefMaxDistance(StartBerriesID, 30);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnits);
		rmAddObjectDefConstraint(StartBerriesID, avoidMediumBerries);
	    rmAddObjectDefConstraint(StartBerriesID, avoidAll);
	    
		// DEFINE THE START FOOD:
		int startFoodID=rmCreateObjectDef("starting herd");
	    rmAddObjectDefItem(startFoodID, "ypSerow", 6, 4.0);
	    rmSetObjectDefMinDistance(startFoodID, 25.0);
	    rmSetObjectDefMaxDistance(startFoodID, 35.0);
		rmAddObjectDefToClass(startFoodID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(startFoodID, avoidStartingUnits);
	    rmSetObjectDefCreateHerd(startFoodID, false);
		rmAddObjectDefConstraint(startFoodID, avoidAll);
	    	      
        // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
        rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
        rmSetObjectDefMinDistance(playerNuggetID, 25.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
		rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
		rmAddObjectDefConstraint(playerNuggetID, avoidMediumNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	         
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************ PLACE THE STARTING TCID AND THE STARTING UNITS AND RESOURCES: *********************** //  
/*================================================================================================================*/
  
        rmClearClosestPointConstraints();

	    for(i=1; < cNumberPlayers) 
{
		// PLACE THE STARTING TCID:
		int placedTC = rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE START SILVER:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE START TREE:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        		
        // FOOD:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
      
		rmPlaceObjectDefAtLoc(startFoodID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    
        // PLACE A NUGGET FOR THE PLAYER:
        rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
      
		// DEFINE THE WATER SPAWN POINT:
		int waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
        rmAddClosestPointConstraint(flagEdgeConstraint);
		vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
		
		// PLACE THE WATER SPAWN POINT:
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));

        rmClearClosestPointConstraints();
  }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //  
/*================================================================================================================*/
  
        // THE FORESTS:
		
		int failCount=0;
 
		int forestTreeID = 0;
    
		if (cNumberNonGaiaPlayers <=2)
		int numTries = 8*cNumberNonGaiaPlayers;
		else
		numTries = 4*cNumberNonGaiaPlayers;
			    
		for (i=0; <numTries)	
{   
        int forestID=rmCreateArea("forest"+i);
        rmAddAreaToClass(forestID, rmClassID("classForest"));
        rmSetAreaWarnFailure(forestID, false);
		
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmSetAreaSize(forestID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
	    else
		rmSetAreaSize(forestID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(325));
        
		rmSetAreaForestType(forestID, "Borneo Forest");
        
		rmSetAreaForestDensity(forestID, 0.75);
        rmSetAreaForestClumpiness(forestID, 0.50);
        rmSetAreaForestUnderbrush(forestID, 0.25);
        
		rmSetAreaMinBlobs(forestID, 1);
        rmSetAreaMaxBlobs(forestID, 2);	
        rmSetAreaMinBlobDistance(forestID, 6.0);
        rmSetAreaMaxBlobDistance(forestID, 10.0);
        
		rmSetAreaCoherence(forestID, 0.4);
        rmSetAreaSmoothDistance(forestID, 10);
        
		rmAddAreaConstraint(forestID, playerVeryCloseConstraint);  
        rmAddAreaConstraint(forestID, avoidCloseTradeRoute);
		rmAddAreaConstraint(forestID, avoidCloseSocket);
        rmAddAreaConstraint(forestID, forestMediumConstraint);
        rmAddAreaConstraint(forestID, avoidCloseNatives);
        rmAddAreaConstraint(forestID, avoidCloseImpassableLand);
    
        if(rmBuildArea(forestID)==false)
    {
        // Stop trying once we fail 5 times in a row.  
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 

        failCount=0; 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ***************************************** CHECK FOR KOTH GAME MODE: ****************************************** //
/*================================================================================================================*/

        if(rmGetIsKOTH()) 
    {
        int randLoc = rmRandInt(1,2);
        float xLoc = 0.5;
        float yLoc = 0.5;
        float walk = 0.075;
    
        ypKingsHillLandfill(xLoc, yLoc, .0075, 2.0, "borneo_sand_a", 0);
        ypKingsHillPlacer(xLoc, yLoc, walk, 0);
        rmEchoInfo("XLOC = "+xLoc);
        rmEchoInfo("XLOC = "+yLoc);
    }
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //  
/*================================================================================================================*/

	    int silverID = -1;
		
		if (cNumberNonGaiaPlayers <=2)
		int silverCount = 6;
		else
		silverCount = 3;
  
	    rmEchoInfo("silver count = "+silverCount);
   
        // SILVER MINES OVER THE ENTIRETY OF THE ISLAND:
        silverID = rmCreateObjectDef("closer silver mines"+i);
        rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, rmXFractionToMeters(0.0));
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(1.0));
        
		rmAddObjectDefConstraint(silverID, avoidFarSilver);
		rmAddObjectDefConstraint(silverID, playerVeryCloseConstraint);
		rmAddObjectDefConstraint(silverID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidCloseSocket);
		rmAddObjectDefConstraint(silverID, forestCloseConstraint);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
		rmAddObjectDefConstraint(silverID, avoidCloseImpassableLand);
		        
		rmPlaceObjectDefPerPlayer(silverID, false, silverCount);
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** // 
/*================================================================================================================*/
		
        // THE NUGGETS EASY:
		int nugget1= rmCreateObjectDef("nugget easy"); 
        rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget1, rmXFractionToMeters(0.0));
        rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
        rmSetNuggetDifficulty(1, 3);
        
		rmAddObjectDefConstraint(nugget1, avoidCloseImpassableLand);
        rmAddObjectDefConstraint(nugget1, avoidFarNugget);
        rmAddObjectDefConstraint(nugget1, playerVeryCloseConstraint);
        rmAddObjectDefConstraint(nugget1, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(nugget1, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget1, avoidMediumSilver);
		rmAddObjectDefConstraint(nugget1, forestCloseConstraint);
		rmAddObjectDefConstraint(nugget1, avoidCloseNatives);
		        
		if (cNumberNonGaiaPlayers<=2)
	    rmPlaceObjectDefAtLoc(nugget1, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);
		else
		rmPlaceObjectDefAtLoc(nugget1, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.92);
/*================================================================================================================*/
// ******************************** RESOURCES THAT CAN BE PLACED AFTER FORESTS: ********************************* //
/*================================================================================================================*/  
        
		// THE HUNTABLE 1: 
		int food1ID=rmCreateObjectDef("huntable1");
		rmAddObjectDefItem(food1ID, "ypSerow", rmRandInt(8,10), 6.0);
	    rmSetObjectDefCreateHerd(food1ID, true);
	    rmSetObjectDefMinDistance(food1ID, 0.0);
	    rmSetObjectDefMaxDistance(food1ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(food1ID, avoidFarHuntable1);
		rmAddObjectDefConstraint(food1ID, avoidCloseImpassableLand);
        rmAddObjectDefConstraint(food1ID, avoidCloseNugget);
        rmAddObjectDefConstraint(food1ID, playerVeryCloseConstraint);
        rmAddObjectDefConstraint(food1ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(food1ID, avoidCloseSocket);
		rmAddObjectDefConstraint(food1ID, avoidCloseSilver);
		rmAddObjectDefConstraint(food1ID, forestCloseConstraint);
		rmAddObjectDefConstraint(food1ID, avoidCloseNatives);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(food1ID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
	    else
		rmPlaceObjectDefAtLoc(food1ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
				
/*================================================================================================================*/		
  
        // THE HUNTABLE 2:
		int food2ID=rmCreateObjectDef("huntable2");
	    rmAddObjectDefItem(food2ID, "ypWildElephant", rmRandInt(2,3), 6.0);
	    rmSetObjectDefCreateHerd(food2ID, true);
	    rmSetObjectDefMinDistance(food2ID, 0.0);
	    rmSetObjectDefMaxDistance(food2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(food2ID, playerVeryCloseConstraint);
	    rmAddObjectDefConstraint(food2ID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(food2ID, avoidMediumHuntable1);
	    rmAddObjectDefConstraint(food2ID, avoidFarHuntable2);
	    rmAddObjectDefConstraint(food2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(food2ID, avoidCloseNugget);
        rmAddObjectDefConstraint(food2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(food2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(food2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(food2ID, avoidCloseNatives);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(food2ID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
	    else
		rmPlaceObjectDefAtLoc(food2ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.94);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRIES: ***************************************** //
/*================================================================================================================*/
   
        // THE BERRIES:
        int berriesID=rmCreateObjectDef("berries");
	    rmAddObjectDefItem(berriesID, "berrybush", 5, 4.0);
	    rmSetObjectDefMinDistance(berriesID, 0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berriesID, avoidFarBerries);
		rmAddObjectDefConstraint(berriesID, playerVeryCloseConstraint);
	    rmAddObjectDefConstraint(berriesID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(berriesID, avoidCloseHuntable1);
	    rmAddObjectDefConstraint(berriesID, avoidCloseHuntable2);
	    rmAddObjectDefConstraint(berriesID, avoidCloseSilver);
		rmAddObjectDefConstraint(berriesID, avoidCloseNugget);
        rmAddObjectDefConstraint(berriesID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(berriesID, avoidCloseSocket);
		rmAddObjectDefConstraint(berriesID, forestCloseConstraint);
		rmAddObjectDefConstraint(berriesID, avoidCloseNatives);
        
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SEAFOOD: **************************************** //    
/*================================================================================================================*/

        // THE FISH 1:
		int fishID=rmCreateObjectDef("fish 1");
        rmAddObjectDefItem(fishID, "ypFishMolaMola", 1, 0.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		rmAddObjectDefConstraint(fishID, playerCloseEdgeConstraint);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
		    
        // THE FISH 2:
		int fish2ID=rmCreateObjectDef("fish 2");
        rmAddObjectDefItem(fish2ID, "ypFishTuna", 1, 0.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFish2ID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
		rmAddObjectDefConstraint(fish2ID, playerCloseEdgeConstraint);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
  
        // EXTRA FISH FOR UNDER 5 PLAYERS:
        if (cNumberNonGaiaPlayers < 5) 
	{
        int fish3ID=rmCreateObjectDef("fish 3");
        rmAddObjectDefItem(fish3ID, "ypFishMolaMola", 1, 0.0);
        rmSetObjectDefMinDistance(fish3ID, 0.0);
        rmSetObjectDefMaxDistance(fish3ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish3ID, fishVsFishID);
        rmAddObjectDefConstraint(fish3ID, fishLand);
		rmAddObjectDefConstraint(fish3ID, playerCloseEdgeConstraint);
        rmPlaceObjectDefAtLoc(fish3ID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
    }  
    
        // THE WHALE:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);  
        rmAddObjectDefConstraint(whaleID, whaleEdgeConstraint); // to keep whales from the edge of the map...
        rmAddObjectDefConstraint(whaleID, whaleLand);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
  
        // THE WATER NUGGETS:
        int nuggetW= rmCreateObjectDef("nugget water"); 
        rmAddObjectDefItem(nuggetW, "ypNuggetBoat", 1, 0.0);
        rmSetNuggetDifficulty(5, 5);
        rmSetObjectDefMinDistance(nuggetW, rmXFractionToMeters(0.0));
        rmSetObjectDefMaxDistance(nuggetW, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nuggetW, avoidLand);
        rmAddObjectDefConstraint(nuggetW, avoidNuggetWater);
        rmAddObjectDefConstraint(nuggetW, nuggetVsFlag);
		rmAddObjectDefConstraint(nuggetW, playerEdgeConstraint);
        rmPlaceObjectDefAtLoc(nuggetW, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/















